// NT 3.51 DDE stuff

#include "stdafx.h"
#include "Setup.h"
#include "ddeml.h"



CONVCONTEXT   CCFilter = { sizeof (CONVCONTEXT), 0, 0, 0, 0L, 0L };
static DWORD lIdInst, lIdInst2;

HDDEDATA CALLBACK GroupDDECallback (UINT uiType, UINT uiFmt, HANDLE hConv,
      HSZ sz1, HSZ sz2, HDDEDATA hData, LONG lData1, LONG lData2) 
{
	return ((HDDEDATA) NULL);
}/* end GroupDDECallback */

BOOL DDECreateGroup (LPCSTR GroupName) 
{
	HDDEDATA   hData;
	//LPSTR      szText;
	LPSTR      szCommand;
	HCONV      hConv;
	HSZ        szProgMan;
	DWORD       lResult;

	// Allocate a block of memory for the group name that the user has selected.
	//szText = VirtualAlloc (NULL, 64, MEM_COMMIT, PAGE_READWRITE);

	// Allocate a block of memory for the command to send to the Program Manager.
	szCommand = (LPSTR) VirtualAlloc (NULL, 128, MEM_COMMIT, PAGE_READWRITE);
	if (szCommand) 
	{
		// We got the memory so we can proceed.

		// Initialize the DDE conversation here.

		if (DdeInitialize (&lIdInst, (PFNCALLBACK) GroupDDECallback,
			(DWORD) APPCMD_CLIENTONLY, 0L)) 
		{
			AfxMessageBox("DDEML Initialization Failure");
			//VirtualFree (szText, 128, MEM_DECOMMIT);
			VirtualFree (szCommand, 128, MEM_DECOMMIT);
			return FALSE;
		}/*endIf*/

		// Create a DDEML string handle for the Program Manager.
		szProgMan = DdeCreateStringHandle (lIdInst, "PROGMAN", CP_WINANSI);
		if (szProgMan) 
		{

			// String handle created so continue.

			// Establish a conversation with the Program Manager.
			hConv = DdeConnect (lIdInst, szProgMan, szProgMan, &CCFilter);

			// Create the group by creating the command line.
			// The program manager will activate an existing group if the name matches
			// a DDE attempt to create a new group so the create versus show is somewhat
			// redundant.
			sprintf (szCommand, "[CreateGroup(%s)]", GroupName);

			// Create a DDEML data handle for the command.
			hData = DdeCreateDataHandle (lIdInst, (LPBYTE)szCommand,
				strlen (szCommand) + 1, 0, (HSZ) NULL, CF_TEXT, 0L);

			// Send the transaction to the server waiting a maximum of 10 seconds.
			// The server will release the data handle.
			if (!DdeClientTransaction ((LPBYTE) hData, 0xFFFFFFFF, hConv,
				(HSZ) NULL, 0, XTYP_EXECUTE, 10000, &lResult)) 
			{

				// If it fails get the error code.
				lResult = DdeGetLastError (lIdInst);
				AfxMessageBox ("DdeClientTransaction Failed");
			}/*endIf*/

						// Group already exists so activate it.
			sprintf (szCommand, "[ShowGroup(%s,1)]", GroupName);

			// Create a DDEML data handle for the command.
			hData = DdeCreateDataHandle (lIdInst, (LPBYTE)szCommand, strlen (szCommand),
				0, (HSZ) NULL, CF_TEXT, 0L);

			// Send the transaction to the server waiting a maximum of 10 seconds.
			// The server will release the data handle.
			if (!DdeClientTransaction ((LPBYTE) hData, 0xFFFFFFFF, hConv,
				(HSZ) NULL, 0, XTYP_EXECUTE, 10000, &lResult)) 
			{

				// If it fails get the error code.
				lResult = DdeGetLastError (lIdInst);
			}/*endIf*/
		
			// Release the Program Manager string handle.
			DdeFreeStringHandle (lIdInst, szProgMan);

			// Disconnect from the server.
			DdeDisconnect (hConv);
		} 
		else 
		{
			lResult = DdeGetLastError (lIdInst);
		}/*endIf*/

		// Free the two blocks of memory that were allocated.
		//VirtualFree (szText, 64, MEM_DECOMMIT);
		VirtualFree (szCommand, 64, MEM_DECOMMIT);

		// Uninitialize the conversation here so that resources are freed.

		DdeUninitialize (lIdInst);
		lIdInst = 0L;
		return (TRUE);
	} 
	else 
	{
		AfxMessageBox("Memory Allocation failure");
	}
	
	return (FALSE);
}/* end CreateGroup */


BOOL DDEAddProgramItem(LPCSTR szProgName, LPCSTR szExePath) 
{
	HDDEDATA  hData;
	HCONV     hConv;
	HSZ       szProgMan;
	DWORD     lResult;
	LPSTR     szExecuteString;
	LPSTR			PrgBuf = strdup(szExePath);
	LPSTR			PrgName = strrchr(PrgBuf,'\\');
	LPSTR			PrgPath = PrgBuf;
	
	*PrgName++ = 0;
	
	{

		// Establish a new conversation.
		if (DdeInitialize (&lIdInst2, (PFNCALLBACK) GroupDDECallback, (DWORD) APPCMD_CLIENTONLY, 0L)) 
		{
			return (FALSE);
		}

		// Create a DDEML string handle for the Program Manager.
		szProgMan = DdeCreateStringHandle (lIdInst2, "PROGMAN", CP_WINANSI);

		// Establish the conversation.
		hConv = DdeConnect (lIdInst2, szProgMan, szProgMan, &CCFilter);

		// Release the string handle that we created.
		DdeFreeStringHandle (lIdInst2, szProgMan);

		szExecuteString = (LPSTR)VirtualAlloc (NULL, MAX_PATH * 4, MEM_COMMIT, PAGE_READWRITE);
		{
			// Create the command string to Replace the item if it exist
			sprintf (szExecuteString, "[ReplaceItem(\"%s\")]", szProgName);

			// Create a DDEML Data handle for the command string.
			hData = DdeCreateDataHandle (lIdInst2, (LPBYTE)szExecuteString,
				strlen (szExecuteString) + 1, 0, (HSZ) NULL, CF_TEXT, 0L);

			// Send the command over to the program manager.
			if (!DdeClientTransaction ((LPBYTE) hData, 0xFFFFFFFF,
				hConv, (HSZ) NULL, 0, XTYP_EXECUTE, 1000, &lResult)) 
			{
				lResult = DdeGetLastError (lIdInst2);
			}

			// Create the command string to add the item.
			sprintf (szExecuteString, "[AddItem(\"%s\",\"%s\",\"%s\",0,0,0,\"%s\")]", 
				szExePath, szProgName, szExePath, PrgPath);

			// Create a DDEML Data handle for the command string.
			hData = DdeCreateDataHandle (lIdInst2, (LPBYTE)szExecuteString,
				strlen (szExecuteString) + 1, 0, (HSZ) NULL, CF_TEXT, 0L);

			// Send the command over to the program manager.
			if (!DdeClientTransaction ((LPBYTE) hData, 0xFFFFFFFF,
				hConv, (HSZ) NULL, 0, XTYP_EXECUTE, 1000, &lResult)) 
			{
				lResult = DdeGetLastError (lIdInst2);
			}
		}

		// Release the command line memory.
		VirtualFree (szExecuteString, MAX_PATH * 4, MEM_DECOMMIT);

		// Disoconnect the DDEML Conversation
		DdeDisconnect (hConv);	
	}

	// Uninitialize the local conversation.
	DdeUninitialize (lIdInst2);
	lIdInst2 = 0L;
	return TRUE;
}


BOOL DDEGroupRetrieval (CComboBox& ListBox)
{
	LPBYTE     lpByte;
	LPSTR      szGroups;
	LPSTR      szToken;
	LPSTR      szMem;
	LPSTR      szToken2;
	DWORD       lResult;
	DWORD       lIdLocal;
	HCONV      hConv;
	HDDEDATA   hDdeData;
	HSZ        szProgMan;
	HSZ        szTopic;


	// Initialize the Dde id to 0

	lIdLocal = 0L;
	szGroups = NULL;

	// Attempt to initialize a conversation.

	if (DdeInitialize (&lIdLocal, (PFNCALLBACK) GroupDDECallback,
		(DWORD) APPCMD_CLIENTONLY, 0L)) 
	{ 
		return (FALSE);
	}/*endIf*/

	// Start a critical section. This fixes a problem where the DDEML
	// Can hang under threaded conditions.


	// Create a string handle for the Dde conversation.

	szProgMan = DdeCreateStringHandle (lIdLocal, "PROGMAN", CP_WINANSI);
	
	// Connect to the program manager.

	hConv = DdeConnect (lIdLocal, szProgMan, szProgMan, &CCFilter);

	// Create a handle for the Group topic.

	szTopic = DdeCreateStringHandle (lIdLocal, "Groups", CP_WINANSI);

	// Execute a request for the group names.

	hDdeData = DdeClientTransaction (NULL, 0L, hConv, szTopic, CF_TEXT,
		XTYP_REQUEST, 1000, &lResult);

	DdeFreeStringHandle (lIdLocal, szProgMan);
	DdeFreeStringHandle (lIdLocal, szTopic);

	// Disconnect the conversation.

	DdeDisconnect (hConv);

	// Verify that we got something back.

	if (hDdeData && (hDdeData != (HDDEDATA) TRUE)) 
	{

		// Access the data to get a character pointer.

		lpByte = DdeAccessData (hDdeData, &lResult);

		// allocate a block of memory to use.

		szGroups = szMem = (LPSTR)VirtualAlloc (NULL, lResult, MEM_COMMIT,
			PAGE_READWRITE);
		if (!szMem) 
		{
			lResult = GetLastError ();
		} 
		else 
		{

			// Copy the Dde data to our own block.

			memcpy (szGroups, lpByte, lResult);
		}/*endIf*/

		// Free the Dde data that is there. This is our responsibility.

		DdeUnaccessData (hDdeData);
		DdeFreeDataHandle (hDdeData);
	}/*endIf*/

	// If we have a memory block then parse it.

	if (szMem != NULL) 
	{

		// Search for 'cr'.

		szToken = strtok (szGroups, "\n");

		// While we have a token use it.

		while (szToken) 
		{

			// We have to strip out line feeds.

			if (szToken2 = strrchr (szToken, 0x0d)) 
			{
				*szToken2 = '\0';
			}/*endIf*/
      
			// Add the resulting string to the combo box of groups.

			ListBox.AddString(szToken);

			// Find the next 'cr'.

			szToken = strtok (NULL, "\n");
		}/*endWhile*/

		// Release the memory block.

		VirtualFree (szMem, lResult, MEM_DECOMMIT);
	}/*endIf*/

	// Release the DDEML.

	DdeUninitialize (lIdLocal);

	return (TRUE);
}/* end GroupRetrieval */


