// FileProperties.cpp : implementation file
//

#include "stdafx.h"
#include "WarSetupWiz.h"
#include "FileProperties.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CFileProperties dialog


CFileProperties::CFileProperties(CWnd* pParent /*=NULL*/)
	: CDialog(CFileProperties::IDD, pParent)
{
	//{{AFX_DATA_INIT(CFileProperties)
	m_Destination = _T("");
	m_Source = _T("");
	m_MenuMode = 0;
	m_MenuName = _T("");
	//}}AFX_DATA_INIT
}


void CFileProperties::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CFileProperties)
	DDX_Text(pDX, IDC_DEST, m_Destination);
	DDX_Text(pDX, IDC_SRC, m_Source);
	DDX_CBIndex(pDX, IDC_MENUMODE, m_MenuMode);
	DDX_Text(pDX, IDC_MENUNAME, m_MenuName);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CFileProperties, CDialog)
	//{{AFX_MSG_MAP(CFileProperties)
	ON_BN_CLICKED(IDC_BROWSE, OnBrowse)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFileProperties message handlers

void CFileProperties::OnBrowse() 
{
	OPENFILENAME o;
	char buf[MAX_PATH];
	CString cBuf;
	
	if (m_Source.IsEmpty())
	{
		cBuf = AfxGetApp()->GetProfileString("File Properties","Src Path","");
		strcpy(buf,cBuf);
	}
	else
		strcpy(buf,m_Source);
	
	o.lStructSize = sizeof(o);
	o.hwndOwner = this->m_hWnd;
	o.hInstance = (HINSTANCE)0;
	o.lpstrFilter = "Executable Files\0*.exe;*.bat;*.com\0All files\0*.*\0\0";
	o.lpstrCustomFilter = NULL;
	o.nMaxCustFilter = 0;
	o.nFilterIndex = 1;
	o.lpstrFile = buf;
	o.nMaxFile = MAX_PATH;
	o.lpstrFileTitle = NULL;
	o.nMaxFileTitle = 0;
	o.lpstrInitialDir = NULL;
	o.lpstrTitle = "Select Executable Script file or Program";
	o.Flags = OFN_EXPLORER | OFN_FILEMUSTEXIST | OFN_NOCHANGEDIR | OFN_HIDEREADONLY;
	o.nFileOffset = 0;
	o.nFileExtension = 0;
	o.lpstrDefExt = ".bat";
	o.lCustData = 0;
	o.lpfnHook = (LPOFNHOOKPROC)0;
	o.lpTemplateName = NULL;

	if (GetOpenFileName(&o))
	{
		m_Source = buf;
		UpdateData(FALSE);
		AfxGetApp()->WriteProfileString("File Properties","Src Path",buf);
	}
}
