// Dialogs.cpp : implementation file
//

#include "stdafx.h"
#include "Setup.h"
#include "Dialogs.h"

extern CSetupApp theApp;
extern char WinDir[MAX_PATH];
extern char SystemDir[MAX_PATH];
extern char ProgramFolderDir[MAX_PATH];
extern char UserProgramFolderDir[MAX_PATH];
extern char ProgramDir[MAX_PATH];
extern int  OsType;

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

CInstallSheet *InstallSheet;
extern BOOL DDEGroupRetrieval (CComboBox& ListBox);

/////////////////////////////////////////////////////////////////////////////
// CInitDlg dialog


CInitDlg::CInitDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CInitDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CInitDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void CInitDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CInitDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CInitDlg, CDialog)
	//{{AFX_MSG_MAP(CInitDlg)
		// NOTE: the ClassWizard will add message map macros here
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CInitDlg message handlers
/////////////////////////////////////////////////////////////////////////////
// CWelcomeTab property page

IMPLEMENT_DYNCREATE(CWelcomeTab, CPropertyPage)

CWelcomeTab::CWelcomeTab() : CPropertyPage(CWelcomeTab::IDD)
{
	//{{AFX_DATA_INIT(CWelcomeTab)
	m_DstPath = _T("");
	m_Welcome = _T("");
	//}}AFX_DATA_INIT
}

CWelcomeTab::~CWelcomeTab()
{
}

void CWelcomeTab::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CWelcomeTab)
	DDX_Text(pDX, IDC_PATH, m_DstPath);
	DDX_Text(pDX, IDC_WELCOME, m_Welcome);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CWelcomeTab, CPropertyPage)
	//{{AFX_MSG_MAP(CWelcomeTab)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CWelcomeTab message handlers

BOOL CWelcomeTab::OnInitDialog() 
{
	CPropertyPage::OnInitDialog();

	m_Welcome.Format("War Install for Windows95 and NT\r\n\r\nThis program will install %s on your PC.",
		(LPCSTR)theApp.m_Name);

	m_DstPath.Format("%s\\%s", ProgramDir, (LPCSTR)theApp.m_InstallDir);

	UpdateData(FALSE);
	
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

BOOL CWelcomeTab::OnSetActive( )
{
	InstallSheet->SetWizardButtons(PSWIZB_NEXT);
	return CPropertyPage::OnSetActive();
}

/////////////////////////////////////////////////////////////////////////////
// CInstallType property page

IMPLEMENT_DYNCREATE(CInstallType, CPropertyPage)

CInstallType::CInstallType() : CPropertyPage(CInstallType::IDD)
{
	//{{AFX_DATA_INIT(CInstallType)
	m_Mode = 0;
	//}}AFX_DATA_INIT
}

CInstallType::~CInstallType()
{
}

void CInstallType::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CInstallType)
	DDX_Radio(pDX, IDC_MODE, m_Mode);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CInstallType, CPropertyPage)
	//{{AFX_MSG_MAP(CInstallType)
		// NOTE: the ClassWizard will add message map macros here
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CInstallType message handlers

BOOL CInstallType::OnSetActive( )
{
	InstallSheet->SetWizardButtons(PSWIZB_NEXT | PSWIZB_BACK);
	return CPropertyPage::OnSetActive();
}

LRESULT CInstallType::OnWizardNext()
{
	UpdateData();

	if (m_Mode != 2) // Custom
		return IDD_SELECTFOLDER;

	return CPropertyPage::OnWizardNext();
}


/////////////////////////////////////////////////////////////////////////////
// CModules property page

IMPLEMENT_DYNCREATE(CModules, CPropertyPage)

CModules::CModules() : CPropertyPage(CModules::IDD)
{
	int Index;
	//{{AFX_DATA_INIT(CModules)
	//}}AFX_DATA_INIT
	for(Index = 0; Index < 10; Index++)
		m_Module[Index] = FALSE;
}

CModules::~CModules()
{
}

void CModules::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	int Index;
	for(Index = 0; Index < 10; Index++)
		DDX_Check(pDX, IDC_CHECK1 + Index, m_Module[Index]);
	//{{AFX_DATA_MAP(CModules)
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CModules, CPropertyPage)
	//{{AFX_MSG_MAP(CModules)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CModules message handlers

BOOL CModules::OnInitDialog() 
{
	int Index;
	CClassList *cl;
	CPropertyPage::OnInitDialog();
	
	for(cl = theApp.m_FileClassRoot, Index = 0; cl; cl = cl->m_Next, Index++)
	{
		if (Index > 9)
			break;

		SetDlgItemText(IDC_CHECK1 + Index, cl->m_Name);
		m_Module[Index] = cl->m_IsTypical;
	}

	for(;Index < 10; Index++)
		GetDlgItem(IDC_CHECK1 + Index)->ShowWindow(SW_HIDE);

	UpdateData(FALSE);
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}


/////////////////////////////////////////////////////////////////////////////
// CSelectFolder dialog
IMPLEMENT_DYNCREATE(CSelectFolder, CPropertyPage)

CSelectFolder::CSelectFolder() : CPropertyPage(CSelectFolder::IDD)
{
	//{{AFX_DATA_INIT(CSelectFolder)
	m_FolderText = _T("");
	m_Folder = _T("");
	//}}AFX_DATA_INIT
}


void CSelectFolder::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSelectFolder)
	DDX_Control(pDX, IDC_COMBO1, m_Combo);
	DDX_Text(pDX, IDC_FOLDERTEXT, m_FolderText);
	DDX_CBString(pDX, IDC_COMBO1, m_Folder);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CSelectFolder, CPropertyPage)
	//{{AFX_MSG_MAP(CSelectFolder)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSelectFolder message handlers

BOOL CSelectFolder::OnInitDialog() 
{
	CPropertyPage::OnInitDialog();
	
	m_FolderText.Format("Select a name for the Start Menu entry (or Program Folder in Windows NT 3.51).");
	m_Folder = theApp.m_Menu;

	if ((OsType == OS_WIN95) || (OsType == OS_NT4))
	{
		// Get start groups - use user selection for now...
		HANDLE h;
		WIN32_FIND_DATA Data;
		CString cBuf;
		cBuf.Format("%s\\*", UserProgramFolderDir);

		if ((h = FindFirstFile(cBuf,&Data)) != INVALID_HANDLE_VALUE)
		{
			do
			{
				if (!(Data.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY))
					continue;
				if (!strcmp(Data.cFileName,".") || !strcmp(Data.cFileName,".."))
					continue;

				m_Combo.AddString(Data.cFileName);

			} while(FindNextFile(h,&Data));
			FindClose(h);
		}
	}
	if (OsType == OS_NT351)
	{
		DDEGroupRetrieval(m_Combo);
	}
	

	UpdateData(FALSE);
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

BOOL CSelectFolder::OnSetActive( )
{
	InstallSheet->SetWizardButtons(PSWIZB_BACK | PSWIZB_NEXT);
	return CPropertyPage::OnSetActive();
}

LRESULT CSelectFolder::OnWizardBack()
{
	if (InstallSheet->m_Tab2.m_Mode != 2) // Not Custom
		return IDD_SELECT_MODE;

	return CPropertyPage::OnWizardBack();
}


/////////////////////////////////////////////////////////////////////////////
// CFinish property page

IMPLEMENT_DYNCREATE(CFinish, CPropertyPage)

CFinish::CFinish() : CPropertyPage(CFinish::IDD)
{
	//{{AFX_DATA_INIT(CFinish)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}

CFinish::~CFinish()
{
}

void CFinish::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CFinish)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CFinish, CPropertyPage)
	//{{AFX_MSG_MAP(CFinish)
		// NOTE: the ClassWizard will add message map macros here
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFinish message handlers
BOOL CFinish::OnSetActive( )
{
	InstallSheet->SetWizardButtons(PSWIZB_BACK | PSWIZB_FINISH);
	return CPropertyPage::OnSetActive();
}


/////////////////////////////////////////////////////////////////////////////
// CInstallSheet

IMPLEMENT_DYNAMIC(CInstallSheet, CPropertySheet)

CInstallSheet::CInstallSheet(LPCTSTR pszCaption, CWnd* pParentWnd, UINT iSelectPage)
	:CPropertySheet(pszCaption, pParentWnd, iSelectPage)
{
	AddPage(&m_Tab1);
	AddPage(&m_Tab2);
	AddPage(&m_Tab3);
	AddPage(&m_Tab4);
	AddPage(&m_Finish);
	SetWizardMode();
	InstallSheet = this;
}

CInstallSheet::~CInstallSheet()
{
	InstallSheet = NULL;
}


BEGIN_MESSAGE_MAP(CInstallSheet, CPropertySheet)
	//{{AFX_MSG_MAP(CInstallSheet)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CInstallSheet message handlers
/////////////////////////////////////////////////////////////////////////////
// CProgress dialog


CProgress::CProgress(CWnd* pParent /*=NULL*/)
	: CDialog(CProgress::IDD, pParent)
{
	//{{AFX_DATA_INIT(CProgress)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void CProgress::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CProgress)
	DDX_Control(pDX, IDC_STEP, m_Step);
	DDX_Control(pDX, IDC_PROGRESS1, m_Progress);
	DDX_Control(pDX, IDC_CURRENT, m_Current);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CProgress, CDialog)
	//{{AFX_MSG_MAP(CProgress)
		// NOTE: the ClassWizard will add message map macros here
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CProgress message handlers
